All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
roboptim::NTimesDerivableFunction< 2 > Class Template Referenceabstract
Mathematical functions

Explicit specialization for the stop case of NTimesDerivable class. More...

`#include <roboptim/core/n-times-derivable-function.hh>`

Inheritance diagram for roboptim::NTimesDerivableFunction< 2 >:

## Public Member Functions

virtual size_type | derivabilityOrderMax () const
| Returns the maximum derivability order (relevant for N>2 only) More...
virtual | ~NTimesDerivableFunction () throw ()
size_type | derivativeSize () const throw ()
| Return the size of the derivative vector. More...
bool | isValidDerivative (const gradient_t &derivative) const throw ()
| Check if a derivative is valid (check sizes). More...
result_t | operator() (double argument) const throw ()
| Evaluate the function at a specified point. More...
void | operator() (result_t &result, double argument) const throw ()
| Evaluate the function at a specified point. More...
gradient_t | derivative (double argument, size_type order=1) const throw ()
| Compute the derivative of the function. More...
void | derivative (gradient_t &derivative, double argument, size_type order=1) const throw ()
| Compute the derivative of the function. More...
virtual std::ostream & | print (std::ostream &o) const throw ()
| Display the function on the specified output stream. More...
Public Member Functions inherited from roboptim::GenericTwiceDifferentiableFunction< T >
| ROBOPTIM_DIFFERENTIABLE_FUNCTION_FWD_TYPEDEFS_ (GenericDifferentiableFunction< T >)
hessianSize_t | hessianSize () const throw ()
| Return the size of a hessian. More...
bool | isValidHessian (const hessian_t &hessian) const throw ()
| Check if the hessian is valid (check sizes). More...
hessian_t | hessian (const argument_t &argument, size_type functionId=0) const throw ()
| Compute the hessian at a given point. More...
void | hessian (hessian_t &hessian, const argument_t &argument, size_type functionId=0) const throw ()
| Compute the hessian at a given point. More...
Public Member Functions inherited from roboptim::GenericDifferentiableFunction< T >
| ROBOPTIM_FUNCTION_FWD_TYPEDEFS_ (GenericFunction< T >)
size_type | gradientSize () const throw ()
| Return the gradient size. More...
jacobianSize_t | jacobianSize () const throw ()
| Return the jacobian size as a pair. More...
bool | isValidGradient (const gradient_t &gradient) const throw ()
| Check if the gradient is valid (check size). More...
bool | isValidJacobian (const jacobian_t &jacobian) const throw ()
| Check if the jacobian is valid (check sizes). More...
jacobian_t | jacobian (const argument_t &argument) const throw ()
| Computes the jacobian. More...
void | jacobian (jacobian_t &jacobian, const argument_t &argument) const throw ()
| Computes the jacobian. More...
gradient_t | gradient (const argument_t &argument, size_type functionId=0) const throw ()
| Computes the gradient. More...
void | gradient (gradient_t &gradient, const argument_t &argument, size_type functionId=0) const throw ()
| Computes the gradient. More...
Public Member Functions inherited from roboptim::GenericFunction< T >
bool | isValidResult (const result_t &result) const throw ()
| Check the given result size is valid. More...
GenericFunction< T >::size_type | inputSize () const throw ()
| Return the input size (i.e. More...
GenericFunction< T >::size_type | outputSize () const throw ()
| Return the output size (i.e. More...
virtual | ~GenericFunction () throw ()
| Trivial destructor. More...
result_t | operator() (const argument_t &argument) const throw ()
| Evaluate the function at a specified point. More...
void | operator() (result_t &result, const argument_t &argument) const throw ()
| Evaluate the function at a specified point. More...
const std::string & | getName () const throw ()
| Get function name. More...

## Static Public Attributes

static const size_type | derivabilityOrder = 2
| Function derivability order. More...

## Protected Member Functions

| NTimesDerivableFunction (size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...
void | impl_compute (result_t &result, const argument_t &argument) const throw ()
| Function evaluation. More...
virtual void | impl_compute (result_t &result, double t) const =0 throw ()
| Function evaluation. More...
void | impl_gradient (gradient_t &gradient, const argument_t &argument, size_type functionId=0) const throw ()
| Gradient evaluation. More...
virtual void | impl_derivative (gradient_t &derivative, double argument, size_type order=1) const =0 throw ()
| Derivative evaluation. More...
void | impl_hessian (hessian_t &hessian, const argument_t &argument, size_type functionId=0) const throw ()
| Hessian evaluation. More...
Protected Member Functions inherited from roboptim::GenericTwiceDifferentiableFunction< T >
| GenericTwiceDifferentiableFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...
void | setZero (hessian_t &symmetric) const
| Set a symmetric matrix to zero. More...
Protected Member Functions inherited from roboptim::GenericDifferentiableFunction< T >
| GenericDifferentiableFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...
virtual void | impl_jacobian (jacobian_t &jacobian, const argument_t &arg) const throw ()
| Jacobian evaluation. More...
template<>
void | impl_jacobian (jacobian_t &jacobian, const argument_t &argument) const throw()
Protected Member Functions inherited from roboptim::GenericFunction< T >
| GenericFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...

## Additional Inherited Members

Public Types inherited from roboptim::GenericTwiceDifferentiableFunction< T >
typedef matrix_t | hessian_t
| Hessian type. More...
typedef std::pair< size_type, size_type > | hessianSize_t
| Hessian size type represented as a pair of values. More...
Public Types inherited from roboptim::GenericDifferentiableFunction< T >
typedef GenericFunctionTraits < T >::gradient_t | gradient_t
| Gradient type. More...
typedef GenericFunctionTraits < T >::jacobian_t | jacobian_t
| Jacobian type. More...
typedef std::pair< size_type, size_type > | jacobianSize_t
| Jacobian size type (pair of values). More...
Public Types inherited from roboptim::GenericFunction< T >
typedef GenericFunctionTraits < T >::value_type | value_type
| Values type. More...
typedef GenericFunctionTraits < T >::vector_t | vector_t
| Basic vector type. More...
typedef GenericFunctionTraits < T >::matrix_t | matrix_t
| Basic matrix type. More...
typedef GenericFunctionTraits < T >::size_type | size_type
| Size type. More...
typedef GenericFunctionTraits < T >::result_t | result_t
| Type of a function evaluation result. More...
typedef GenericFunctionTraits < T >::argument_t | argument_t
| Type of a function evaluation argument. More...
typedef std::pair< value_type, value_type > | interval_t
| Interval type (lower, upper). More...
typedef std::vector< interval_t > | intervals_t
| Vector of intervals. More...
typedef boost::tuple < value_type, value_type, value_type > | discreteInterval_t
| Types representing a discrete interval. More...
Static Public Member Functions inherited from roboptim::GenericFunction< T >
static value_type | epsilon () throw ()
| Get the value of the machine epsilon, useful for floating types comparison. More...
static value_type | infinity () throw ()
| Get the value that symbolizes positive infinity. More...
static interval_t | makeInterval (value_type l, value_type u) throw ()
| Construct an interval from a lower and upper bound. More...
static interval_t | makeInfiniteInterval () throw ()
| Construct an infinite interval. More...
static interval_t | makeLowerInterval (value_type l) throw ()
| Construct an interval from a lower bound. More...
static interval_t | makeUpperInterval (value_type u) throw ()
| Construct an interval from an upper bound. More...
static double | getLowerBound (const interval_t &interval) throw ()
| Get the lower bound of an interval. More...
static double | getUpperBound (const interval_t &interval) throw ()
| Get the upper bound of an interval. More...
static discreteInterval_t | makeDiscreteInterval (value_type min, value_type max, value_type step)
| Construct a discrete interval. More...
static discreteInterval_t | makeDiscreteInterval (interval_t interval, value_type step)
| Construct a discrete interval. More...
static double | getLowerBound (const discreteInterval_t &interval) throw ()
| Get the lower bound of a discrete interval. More...
static double | getUpperBound (const discreteInterval_t &interval) throw ()
| Get the upper bound of a discrete interval. More...
static double | getStep (const discreteInterval_t &interval) throw ()
| Get the upper step of a discrete interval. More...
template<typename F >
static void | foreach (const discreteInterval_t interval, F functor)
| Iterate on an interval. More...
template<typename F >
static void | foreach (const interval_t interval, const size_type n, F functor)
| Iterate on an interval. More...
Static Protected Attributes inherited from roboptim::GenericFunction< T >
static log4cxx::LoggerPtr | logger
| Pointer to function logger (see log4cxx documentation). More...

## Detailed Description

### template<>
class roboptim::NTimesDerivableFunction< 2 >

Explicit specialization for the stop case of NTimesDerivable class.

This specialization defines the interface of a ``n times derivable function'' and implements generic methods required by upper classes using this class specific interface.

## Constructor & Destructor Documentation

virtual roboptim::NTimesDerivableFunction< 2 >::~NTimesDerivableFunction | ( |  | ) |
throw | ( |
| ) |  |

inline virtual

roboptim::NTimesDerivableFunction< 2 >::NTimesDerivableFunction | ( | size_type | outputSize = `1`,
|  | std::string | name = `std::string ()`
| ) |  |
throw | ( |
| ) |  |

inline protected

Concrete class constructor should call this constructor.

Parameters

  outputSize | output size (result size)
  name | function's name

## Member Function Documentation

virtual size_type roboptim::NTimesDerivableFunction< 2 >::derivabilityOrderMax | ( |  | ) | const

inline virtual

Returns the maximum derivability order (relevant for N>2 only)

gradient_t roboptim::NTimesDerivableFunction< 2 >::derivative | ( | double | argument,
|  | size_type | order = `1`
| ) |  | const
throw | ( |
| ) |  |

inline

Compute the derivative of the function.

Derivative is computed for a certain order, at a given point.

Parameters

  argument | point at which the derivative will be computed
  order | derivative order (if 0 then function is evaluated)

Returns
  derivative vector

void roboptim::NTimesDerivableFunction< 2 >::derivative | ( | gradient_t & | derivative,
|  | double | argument,
|  | size_type | order = `1`
| ) |  | const
throw | ( |
| ) |  |

inline

Compute the derivative of the function.

Derivative is computed for a certain order, at a given point.

Parameters

  derivative | derivative will be stored in this vector
  argument | point at which the derivative will be computed
  order | derivative order (if 0 then function is evaluated)

References roboptim::NTimesDerivableFunction< DerivabilityOrder >::derivabilityOrderMax().

size_type roboptim::NTimesDerivableFunction< 2 >::derivativeSize | ( |  | ) | const
throw | ( |
| ) |  |

inline

Return the size of the derivative vector.

Returns
  derivative vector size

void roboptim::NTimesDerivableFunction< 2 >::impl_compute | ( | result_t & | result,
|  | const argument_t & | argument
| ) |  | const
throw | ( |
| ) |  |

inline protected virtual

Function evaluation.

Implement generic function evaluation, as required by Function, using this class evaluation method (using a double instead of a vector).

Warning
  Do not call this function directly, call #operator()(result_t&, const argument_t&) const throw () instead.

Parameters

  result | result will be stored in this vector
  argument | point at which the function will be evaluated

Implements roboptim::GenericFunction< T >.

virtual void roboptim::NTimesDerivableFunction< 2 >::impl_compute | ( | result_t & | result,
|  | double | t
| ) |  | const
throw | ( |
| ) |  |

protected pure virtual

Function evaluation.

Evaluate the function, has to be implemented in concrete classes.

Warning
  Do not call this function directly, call #operator()(double) const throw () instead.

Parameters

  result | result will be stored in this vector
  t | point at which the function will be evaluated

virtual void roboptim::NTimesDerivableFunction< 2 >::impl_derivative | ( | gradient_t & | derivative,
|  | double | argument,
|  | size_type | order = `1`
| ) |  | const
throw | ( |
| ) |  |

protected pure virtual

Derivative evaluation.

Compute the derivative, has to be implemented in concrete classes.

Warning
  Do not call this function directly, call derivative instead.

Parameters

  derivative | derivative will be store in this argument
  argument | point where the gradient will be computed
  order | derivative order (if 0 evaluates the function)

void roboptim::NTimesDerivableFunction< 2 >::impl_gradient | ( | gradient_t & | gradient,
|  | const argument_t & | argument,
|  | size_type | functionId = `0`
| ) |  | const
throw | ( |
| ) |  |

inline protected virtual

Gradient evaluation.

Implement the gradient computation, as required by DerivableFunction. The gradient is computed for a specific sub-function which id is passed through the functionId argument.

Warning
  Do not call this function directly, call gradient or derivative instead.

Parameters

  gradient | gradient will be store in this argument
  argument | point where the gradient will be computed
  functionId | evaluated function id in the split representation

ROBOPTIM_DO_NOT_CHECK_ALLOCATION

Implements roboptim::GenericDifferentiableFunction< T >.

void roboptim::NTimesDerivableFunction< 2 >::impl_hessian | ( | hessian_t & | hessian,
|  | const argument_t & | argument,
|  | size_type | functionId = `0`
| ) |  | const
throw | ( |
| ) |  |

inline protected virtual

Hessian evaluation.

Implement the hessian computation, as required by the TwiceDerivableFunction class using the derivative method. The hessian is computed for a specific sub-function which id is passed through the functionId argument.

Warning
  Do not call this function directly, call hessian instead.

Parameters

  hessian | hessian will be stored here
  argument | point where the hessian will be computed
  functionId | evaluated function id in the split representation

Implements roboptim::GenericTwiceDifferentiableFunction< T >.

bool roboptim::NTimesDerivableFunction< 2 >::isValidDerivative | ( | const gradient_t & | derivative | ) | const
throw | ( |
| ) |  |

inline

Check if a derivative is valid (check sizes).

Parameters

  derivative | derivative vector to be checked

Returns
  true if valid, false if not

result_t roboptim::NTimesDerivableFunction< 2 >::operator() | ( | double | argument | ) | const
throw | ( |
| ) |  |

inline

Evaluate the function at a specified point.

The program will abort if the argument does not have the expected size.

Parameters

  argument | point at which the function will be evaluated

Returns
  computed result

void roboptim::NTimesDerivableFunction< 2 >::operator() | ( | result_t & | result,
|  | double | argument
| ) |  | const
throw | ( |
| ) |  |

inline

Evaluate the function at a specified point.

The program will abort if the argument does not have the expected size.

Parameters

  result | result will be stored in this vector
  argument | point at which the function will be evaluated

Returns
  computed result

virtual std::ostream& roboptim::NTimesDerivableFunction< 2 >::print | ( | std::ostream & | o | ) | const
throw | ( |
| ) |  |

inline virtual

Display the function on the specified output stream.

Parameters

  o | output stream used for display

Returns
  output stream

Reimplemented from roboptim::GenericTwiceDifferentiableFunction< T >.

References roboptim::NTimesDerivableFunction< DerivabilityOrder >::derivabilityOrderMax().

## Member Data Documentation

const size_type roboptim::NTimesDerivableFunction< 2 >::derivabilityOrder = 2

static

Function derivability order.

One static const variable per class in inheritance structure.